// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_handler_ClientSocket_hpp
#define anna_comm_handler_ClientSocket_hpp

#include <anna/comm/handler/MetaClientSocket.hpp>

namespace anna {

namespace comm {

class ClientSocket;

namespace handler {

class ClientSocket : public MetaClientSocket {
public:
  ClientSocket(Communicator* communicator) :
    MetaClientSocket(communicator, Handler::Type::ClientSocket),
    a_clientSocket(NULL)
  {;}

  void setup(comm::ClientSocket* clientSocket) throw() { a_clientSocket = clientSocket; }

  comm::ClientSocket* getClientSocket() throw() { return a_clientSocket; }

private:
  comm::ClientSocket* a_clientSocket;

  void initialize() throw(RuntimeException);
  void finalize() throw();
  void clone() throw(RuntimeException);
  std::string asString() const throw();
  xml::Node* asXML(xml::Node*) const throw();
};

}
}
}

#endif

