// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_core_functions_hpp
#define anna_core_functions_hpp

#include <stdlib.h>

#include <anna/core/util/ComponentManager.hpp>
#include <anna/core/util/defines.hpp>
#include <anna/core/RuntimeException.hpp>

#include <anna/core/util/ExclusiveHash.hpp>
#include <anna/core/util/Second.hpp>
#include <anna/core/util/Millisecond.hpp>
#include <anna/core/util/Microsecond.hpp>

#include <anna/core/DataBlock.hpp>


#include <time.h>
#include <sys/time.h>
#include <string>
#include <vector>


//------------------------------------------------------------------------------
//---------------------------------------------------------------------- #define
//------------------------------------------------------------------------------
#define s_REGEXP_IPv4_ADDRESSES "\\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\b"
//#define s_REGEXP_IPv6_ADDRESSES "s*((([0-9A-Fa-f]{1,4}:){7}(([0-9A-Fa-f]{1,4})|:))|(([0-9A-Fa-f]{1,4}:){6}(:|((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})|(:[0-9A-Fa-f]{1,4})))|(([0-9A-Fa-f]{1,4}:){5}((:((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){4}(:[0-9A-Fa-f]{1,4}){0,1}((:((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){3}(:[0-9A-Fa-f]{1,4}){0,2}((:((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){2}(:[0-9A-Fa-f]{1,4}){0,3}((:((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:)(:[0-9A-Fa-f]{1,4}){0,4}((:((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(:(:[0-9A-Fa-f]{1,4}){0,5}((:((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})))(%.+)?\\s*"
#define s_REGEXP_IPv6_ADDRESSES "s*((([0-9A-Fa-f]{1,4}:){7}(([0-9A-Fa-f]{1,4})|:))|(([0-9A-Fa-f]{1,4}:){6}(:|((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})\
(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})|(:[0-9A-Fa-f]{1,4})))|(([0-9A-Fa-f]{1,4}:){5}((:((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\
\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){4}(:[0-9A-Fa-f]{1,4}){0,1}((:((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(\
25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){3}(:[0-9A-Fa-f]{1,4}){0,2}((:((25[0-5]|2[0-4]\\d|[01]?\
\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:){2}(:[0-9A-Fa-f]{1,4}){0,3}((:((25[0-5]|2\
[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(([0-9A-Fa-f]{1,4}:)(:[0-9A-Fa-f]{1,4}){0,4}((:\
((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(:(:[0-9A-Fa-f]{1,4}){0,5}((:((25[0-\
5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})?)|((:[0-9A-Fa-f]{1,4}){1,2})))|(((25[0-5]|2[0-4]\\d|[01]?\\d{1,2})(\\.(25[\
0-5]|2[0-4]\\d|[01]?\\d{1,2})){3})))(%.+)?\\s*"

// Helpers for alarm parsing parameters:
#define STRING_WITH_QUOTATION_MARKS__C_STR(x)   ((anna::functions::addQuotationMarks(x)).c_str())
#define ANNA_AS_STRING__C_STR(x)             ((anna::functions::asString(x)).c_str())



namespace anna {

class DataBlock;

#ifdef __CYGWIN__
#define CLOCK_PROCESS_CPUTIME_ID CLOCK_PROCESS_CPUTIME
#endif


/**
   functions - Mtodos y variables
*/
struct functions {
  /**
     Tamao de la memoria reservada que debe tener la variable usada para guardar
     el resultado de convertir el 'time' en texto.

     @see asString
  */
  static const int DateTimeSizeString = 21;

  /**
     @return La versin de functions con la que hemos linkado nuestra aplicacion.
  */
  static std::string getVersion() throw();

  /**
     @return Un literal con la arquitectura sobre la que hemos compilado nuestra aplicacion.
  */
  static std::string getArchitecture() throw();

  /**
     Indica el nmero de bits de un entero.
  */
  static const int intBitSize = sizeof(int) * 8;

  /*
   * Indica el nmero de bits de un entero largo.
   */
  static const int int64BitSize = sizeof(S64) * 8;

  /**
     \param number Numero a convertir.
     @return Un literal con el numero convertido a cadena decimal.
  */
  static std::string asString(const int number) throw();

  /**
     \param number Numero a convertir.
     @return Un literal con el numero sin signo convertido a cadena decimal.
  */
  static std::string asString(const unsigned int number) throw();

  /**
     \param number Numero a convertir.
     @return Un literal con el numero sin signo convertido a cadena decimal.
  */
  static std::string asString(const unsigned long long int number) throw() {
    return asString((U64)number);
  }

  /**
     \param number Numero a convertir.
     @return Un literal con el numero sin signo convertido a cadena decimal.
  */
  static std::string asString(const long long int number) throw() {
    return asString((S64)number);
  }

  /**
     Devuelve un literal con tel numero convertido a cadena decimal
     @return Un literal con el numero signo convertido a cadena decimal.
  */
  static std::string asString(const S64 number) throw();

  /**
     Devuelve un literal con tel numero convertido a cadena decimal
     @return Un literal con el numero signo convertido a cadena decimal.
  */
  static std::string asString(const U64 number) throw();

  /**
     \param _bool Booleano a convertir.
     \return Un literal con el boolean convertido a cadena.
  */
  static const char* asString(const bool _bool) throw() { return (_bool == true) ? "true" : "false"; }

  /**
     Devuelve una cadena con el bloque de datos decodificado en grupos de 16 bytes.
     @param dataBlock Bloque de datos a interpretar.
     \param characterByLine Nmero de caracteres en cada lnea.
     @return Devuelve una cadena con el bloque de datos decodificado en grupos de 16 bytes.
  */
  static std::string asString(const DataBlock& dataBlock, const int characterByLine = 16) throw();

  /**
     Devuelve una cadena con el numero en coma flotante.
     \param v Numero a tratar.
     \param format Formato aplicado para convertir el numero a cadena. Ver \em man printf.
     \return una cadena con el numero en coma flotante.
  */
  static std::string asString(const double v, const char* format = "%e") throw();

  /**
     Devuelve una cadena con el numero en coma flotante.
     \param v Numero a tratar.
     \param format Formato aplicado para convertir el numero a cadena. Ver \em man printf.
     \return una cadena con el numero en coma flotante.
  */
  static std::string asString(const float v, const char* format = "%f") throw();

  /**
     \param comment Comentario que precede al valor.
     \param number Numero a convertir.
     @return Un literal con el numero convertido a cadena decimal.
  */
  static std::string asText(const char* comment, const int number)
  throw() {
    std::string result(comment);
    return result += asString(number);
  }

  /**
     \param comment Comentario que precede al valor.
     \param number Numero a convertir.
     @return Un literal con el numero convertido a cadena decimal.
  */
  static std::string asText(const char* comment, const S64 number)
  throw() {
    std::string result(comment);
    return result += asString(number);
  }

  /**
      \param comment Comentario que precede al valor.
      \param _bool Booleano a convertir.
      @return Un literal con el numero convertido a cadena decimal.
   */
  static std::string asText(const char* comment, const bool _bool)
  throw() {
    std::string result(comment);
    return result += asString(_bool);
  }

  /**
     \param comment Comentario que precede al valor.
     \param dataBlock Bloque de datos a interpretar.
     \param characterByLine Nmero de caracteres en cada lnea.
     @return Un literal con el numero convertido a cadena decimal.
  */
  static std::string asText(const char* comment, const DataBlock& dataBlock, const int characterByLine = 16)
  throw() {
    std::string result(comment);
    return result += asString(dataBlock, characterByLine);
  }

  /**
     \param comment Comentario que precede al valor.
     \param value Numero a tratar.
     \param format Formato aplicado para convertir el numero a cadena. Ver \em man printf.
     \return Un literal con el numero convertido a cadena.
  */
  static std::string asText(const char* comment, const float value, const char* format = "%f")
  throw() {
    std::string result(comment);
    return result += asString(value, format);
  }

  /**
     \param comment Comentario que precede al valor.
     \param value Numero a tratar.
     \param format Formato aplicado para convertir el numero a cadena. Ver \em man printf.
     \return Un literal con el numero convertido a cadena.
  */
  static std::string asText(const char* comment, const double value, const char* format = "%e")
  throw() {
    std::string result(comment);
    return result += asString(value, format);
  }

  /**
     \param number Numero a convertir.
     @return Un literal con el numero convertido a cadena hexadecimal.
  */
  static std::string asHexString(const int number) throw();

  /**
     \param number Numero a convertir.
     @return Un literal con el numero convertido a cadena hexadecimal.
  */
  static std::string asHexString(const S64 number) throw();

  /**
     \param number Numero a convertir.
     @return Un literal con el numero convertido a cadena hexadecimal.
  */
  static std::string asHexString(const U64 number) throw() { return asHexString((S64) number); }

  /**
     \param comment Comentario que precede al valor.
     \param number Numero a convertir.
     @return Un literal con el numero convertido a cadena decimal.
  */
  static std::string asHexText(const char* comment, const int number)
  throw() {
    std::string result(comment);
    return result += asHexString(number);
  }

  /**
     \param comment Comentario que precede al valor.
     \param number Numero a convertir.
     @return Un literal con el numero convertido a cadena decimal.
  */
  static std::string asHexText(const char* comment, const S64 number)
  throw() {
    std::string result(comment);
    return result += asHexString(number);
  }

  /**
    * Devuelve un cadena con el contenido del bloque de datos interpretado como BCD, pero pasa
    * cada valor binario a su correspondiente carcter. Por ejemplo, el buffer aa210c quedar como una cadena "AA210C".
    *
    * \param dataBlock Bloque a codificar.
    * \return La cadena que contiene el valor literal del buffer de datos.
    */
  static std::string asHexString(const DataBlock& dataBlock) throw();

  /**
   * Obtiene el valor original de una cadena obtenido con #asHexString (const DataBlock&).
   * \param hexString Cadena que contiene el bfer.
   * \param target Bloque de datos sobre el que decodificar la cadena.
   * \return El bloque de datos original correspondiente a la cadena recibida.
   */
  static DataBlock& fromHexString(const std::string& hexString, DataBlock& target) throw(RuntimeException);

  /**
     Devuelve una cadena con la hora en formato 'dd/mm/yyyy hh:mm:ss'.

     @param second Hora que deseamos traducir.

     @return Un literal con la hora en el formato 'dd/mm/yyyy hh:mm:ss'.
  */
  static std::string asDateTime(const Second &second) throw();

  /**
      Devuelve una cadena con la hora en formato 'dd/mm/yyyy hh:mm:ss'.

      @param second Hora que deseamos traducir.
      @param result Puntero donde vamos a guardar el resultado de la conversin.
      Debe tener espacio reservado para contener #TimeSizeAsString caracteres.

      @return El puntero recibido como parametro conteniendo el literal con la hora
      en el formato 'dd/mm/yyyy hh:mm:ss'.
   */
  static const char* asDateTime(const Second &second, char* result) throw();

  /**
     Calcula la funcion hash de la cadena recibida como parametro.
     \param str Cadena a la que aplicar la funcion hash.
  */
  static S64 hash(const char* str) throw();

  /**
     Calcula la funcion hash de la cadena recibida como parametro.
     \param str Cadena a la que aplicar la funcion hash.
  */
  static S64 hash(const std::string& str) throw() { return hash(str.c_str()); }

  /**
     Devuelve la cadena que contiene el resultado de aplicar la especificacion \em format
     sobre el resto de los parametros.

     \param format especificacion de formato similiar al empleado en las funciones \em printf,
     \em scanf, etc.

     \return la cadena que contiene el resultado de aplicar la especificacion \em format
     sobre el resto de los parametros.
  */
  static std::string asString(const char* format, ...) throw();

  /**
     Devuelve el resultado de invocar a metodo asString de la clase recibida como parametro.
     Si t es NULL devolvera el texto indicando la sitacion.
     \param t Instancia de la clase a usar. Puede ser NULL.
     \return el resultado de invoca a T::asString () si t es distinto de NULL.
     \warning La clase T debe tener un metodo estatico con la signatura:
     \code
        static const char* className () throw ();
     \endcode
  */
  template <typename T> static std::string asString(const T* t)
  throw() {
    if(t == NULL) {
      std::string result(T::className());
      result += " { <null> }";
      return result;
    }

    return t->asString();
  }

  /**
     Metodo identididad. Facilita la implementacion de patrones donde no se conoce el tipo de dato recibido.

     \param str Instancia de la cadena.
     \return La misma instancia recibida como parametro.
  */
  static const std::string& asString(const std::string& str) throw() { return str; }

  /**
     Detiene la ejecucion del thread durante el numero de milisegundos indicados.

     \param millisecond Numero de milisegundos que vamos a detener la ejecucion de este thread.
  */
  static void sleep(const Millisecond &millisecond) throw();

  /**
     Obtiene el numero de segundos transcurridos desde el 1 del 1 de 1970.
     \return El numero de segundos transcurridos desde el 1 del 1 de 1970.
  */
  static Second second() throw() {
    Second result(::time(NULL));
    return result;
  }

  /**
     Obtiene el numero de microsegundos transcurridos desde el 1 del 1 de 1970.
     \return El numero de microsegundos transcurridos desde el 1 del 1 de 1970.
  */
  static Microsecond microsecond() throw() {
    struct timeval tv;
    gettimeofday(&tv, NULL);
    Microsecond result((Microsecond::type_t)1000000 * tv.tv_sec + tv.tv_usec);
    return result;
  }

  /**
     Obtiene el numero de milisegundos transcurridos desde el 1 del 1 de 1970.
     \return El numero de milisegundos transcurridos desde el 1 del 1 de 1970.
  */
  static Millisecond millisecond() throw() {
    struct timeval tv;
    gettimeofday(&tv, NULL);
    Millisecond result((Millisecond::type_t)1000 * tv.tv_sec + tv.tv_usec / 1000);
    return result;
  }

  /**
     Devuelve la referencia interna de los microsegundos transcurrido en el procesador.
     \return la referencia interna de los microsegundos transcurrido en el procesador.
  */
  static Microsecond hardwareClock() throw() {
    timespec ts;
    //clock_gettime(CLOCK_PROCESS_CPUTIME_ID, &ts); // DONT works (original)
    //clock_gettime(CLOCK_THREAD_CPUTIME_ID, &ts); // DONT works
    //clock_gettime(CLOCK_MONOTONIC, &ts); // works
      // Note that CLOCK_MONOTONIC is subject to discontinuities from system time
      //  adjustment in Linux. CLOCK_MONOTONIC_RAW was defined to get around this
      //  (gets hardware time not adjusted by NTP).
    clock_gettime(CLOCK_MONOTONIC_RAW, &ts); // works

    Microsecond result((Microsecond::type_t)1000000 * ts.tv_sec + ts.tv_nsec / 1000);
    return result;
  }

  /**
     Interpreta la cadena recibida como parametro como un dato de tipo boolean.

     Si la cadena vale NULL, o contiene los literales "false" o "0" devolvera \em false,
     si contiene los literales "true" o "1" devolvera \em true, en otro caso devolvera un excepcion.

     \param str Cadena a interpretar.

     \return El valor booleano correspondiente a la cadena recibida.
  */
  static bool asBool(const char* str) throw(RuntimeException);

  /**
     Interpreta la cadena recibida como parametro como un entero de 32 bits.
     \return
   */
  static int asInteger(const char* str) throw() { return atoi(str); }

  /**
     Interpreta la cadena recibida como parametro como un entero de 32 bits.
     \return
   */
  static S64 asInteger64(const char* str) throw();

  /**
     Devuelve el identificador de thread desde el que es invocado este metodo.
     Si el programa no tuviera soporta para MT siempre devolvera 0.
     \return el identificador de thread desde el que es invocado este metodo.
  */
  static pthread_t getCurrentThread() throw();

  /**
     Devuelve \em true si la version de nucleo que estamos ejecutado soporta multithread o \em false en otro
     caso.
     \return \em true si la version de nucleo que estamos ejecutado soporta multithread o \em false en otro
  */
  static bool supportMultithread() throw() {
    WHEN_SINGLETHREAD(return false);
    WHEN_MULTITHREAD(return true);
  }

  /**
     Devuelve \em true si el valor recibido cumple el patron establecido o \em false en otro caso.
     \param pattern Expresion regular que describe el patron a cumplir.
     \param value Cadena a comparar con el patron.
     \return \em true si el valor recibido cumple el patron establecido o \em false en otro caso.

     \see regexec para mas informacion sobre las expresiones regulares.
  */
  static bool isLike(const char* pattern, const std::string& value) throw(RuntimeException);

  /**
   * Devuelve el nmero de bits necesarios para representar el valor recibido como parmetro.
   * \param n Valor a estudiar.
   * \return el nmero de bits necesarios para representar el valor recibido como parmetro.
   */
  static int bitsize(const int n) throw() {  return (n == 0) ? 1 : functions::log2(n) + 1; }

  /**
   * Devuelve el nmero de bits necesarios para representar el valor recibido como parmetro.
   * \param n Valor a estudiar.
   * \return el nmero de bits necesarios para representar el valor recibido como parmetro.
   */
  static int bitsize(const S64 n) throw() {
    int aux = n >> intBitSize;
    return (aux != 0) ? (bitsize(aux) + intBitSize) : bitsize((int) n);
  }

  /**
   * Calcula la operacin (n1 << bitShit) | n2. Establece las comprobaciones necesarias para verificar
   * que la operacin se realiza correctamente, teniendo especial cuidado de que no se puedan solapar
   * ninguno de los valores.
   *
   * \param whatis Literal que debera identificar el punto de invocacin en caso de que haya algn error.
   * \param n1 Nmero a desplazar el n de bits indicado por \em bitShift.
   * \param bitShift Nmero de bits a desplazar.
   * \param n2 Nmero a combinar con el resultado de la operacin (n1 << bitShift).
   */
  static S64 merge(const char* whatis, const int n1, const int n2, const int bitShift) throw(RuntimeException);

  /**
   * Calcula el logaritmo en base 2 del nmero recibo como parmetro.
   * \param v Valor a calcular.
   * \return El algoritmo en base 2 del nmero recibido como parmetro o -1 si el parmetro recibido es 0.
   */
  static int log2(const unsigned int v) throw();




  //////////////////////////////////////////////////////////////////////////////////////////////////
  // Text format resources /////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////
  struct TextHighlightMode {
    enum _v {
      None = -1, // Initialized
      Overline,
      Underline,
      OverAndUnderline,
      Leftline,
      Rightline,
      LeftAndRightline
    };
  };

  struct TextJustifyMode {
    enum _v {
      None = -1, // Initialized
      Left,
      Center,
      Right
    };
  };

  /**
     Solve singular/plural literal expression for any number.
     <pre>
     Provide (0): returns "no entries"
     Provide (1): returns "1 entry"
     Provide (2): returns "2 entries"

     Provide (0, 'table'): returns "no tables"
     Provide (1, 'table'): returns "1 table"
     Provide (2, 'table'): returns "2 tables"

     Provide (0, 'query', 'queries'): returns "no queries"
     Provide (1, 'query', 'queries'): returns "1 query"
     Provide (2, 'query', 'queries'): returns "2 queries"
     </pre>

     @param number Amount processed
     @param wordForSingular Word used as singular, 'entry' by default.
     @param wordForPlural Word used as plural, 'entries' by default.

     @return Coherent literal as '%d <singular word/plural word>'
  */
  static std::string entriesAsString(int number, const char * wordForSingular = NULL, const char * wordForPlural = NULL) throw();

  /**
     Justify text (traces and output improvement)

     @param title Title processed
     @param mode Justify mode: Left (default), Center, Right
     @param filler Filler character used (space by default)

     @return Processed text
  */
  static std::string justify(const std::string & title, TextJustifyMode::_v mode = TextJustifyMode::Left, char filler = ' ') throw();

  /**
     Highligth text (traces and output improvement)

     @param title Title processed
     @param mode Highlight mode: Overline, Underline(default), OverAndUnderline, Leftline, Rightline, LeftAndRightline
     @param filler Filler character used (dash by default)
     @param appendCR Carriage return inclusion (true by default)

     @return Processed text
  */
  static std::string highlight(const std::string & title, TextHighlightMode::_v mode = TextHighlightMode::Underline, char filler = '-', bool appendCR = true) throw();

  /**
     Highligth and justify text (traces and output improvement)

     @param title Title processed
     @param hMode Highlight mode: Overline, Underline(default), OverAndUnderline, Leftline, Rightline, LeftAndRightline
     @param jMode Justify mode: Left (default), Center, Right
     @param highlightFiller Filler character used (double dash ('=') by default)
     @param justifyFiller Filler character used when justify (space by default)
     @param appendCR Carriage return inclusion (true by default)

     @return Processed text
  */
  static std::string highlightJustify(const std::string & title, TextHighlightMode::_v hMode = TextHighlightMode::OverAndUnderline, TextJustifyMode::_v jMode = TextJustifyMode::Center, char highlightFiller = '=', char justifyFiller = ' ', bool appendCR = true) throw() {
    return(highlight(justify(title, jMode, justifyFiller), hMode, highlightFiller, appendCR));
  }

  /**
     Tabulate text (traces and output improvement)

     @param text Text processed
     @param tabSpaces Tab spaces (three by default)
  */
  static std::string tab(const std::string & text, int tabSpaces = 3) throw();


  //////////////////////////////////////////////////////////////////////////////////////////////////
  // Conversions and helpers ///////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////

  /**
     Pattern to obtain a multi named component instance easily.
     Parameters are usually replaced by the macro C <b>FILE_LOCATION</b>.

     \param className Component class name
     \param fromFile File which called the method
     \param fromLine Line number within the file from where the method is called.

     \return Component instance for the class provided at the pattern
     \see Component
  */
  template <typename T> static T* componentByName(const char *className, const char* fromFile, const int fromLine)
  throw(RuntimeException) {
    ComponentManager &cm = ComponentManager::instantiate();
    T* result = static_cast <T*>(cm.find(className));

    if(result == NULL) {
      std::string msg(className);
      msg += " | Unregistered component";
      throw RuntimeException(msg, fromFile, fromLine);
    }

    return result;
  }

  /**
     Pattern to obtain a single named component instance easily.
     Parameters are usually replaced by the macro C <b>FILE_LOCATION</b>.

     \param fromFile File which called the method
     \param fromLine Line number within the file from where the method is called.

     \return Component instance for the class provided at the pattern
     \warning T class must implement a method in the form:
     \code
         static const char* getClassName () throw ();
     \endcode
     \see Component
  */
  template <typename T> static T* component(const char* fromFile, const int fromLine)
  throw(RuntimeException) {
    return functions::componentByName<T> (T::getClassName(), fromFile, fromLine);
  }

  /**
     Finds string at the end of another

     @param pattern String where we find
     @param suffix Searched string

     @return Boolean about ocurrency
  */
  static bool endsWith(const std::string & pattern, const std::string & suffix) throw() {
    std::string dummy;
    return endsWith(pattern, suffix, dummy);
  }

  /**
     Similar to #endsWith but returning additional preffix string by reference (pattern without suffix)
  */
  static bool endsWith(const std::string & pattern, const std::string & suffix, std::string & preffix) throw();

  /**
     Finds string at the begining of another

     @param pattern String where we find
     @param preffix Searched string

     @return Boolean about ocurrency
  */
  static bool startsWith(const std::string & pattern, const std::string & preffix) throw() {
    std::string dummy;
    return startsWith(pattern, preffix, dummy);
  }

  /**
     Similar to #startsWith but returning additional suffix string by reference (pattern without preffix)
  */
  static bool startsWith(const std::string & pattern, const std::string & preffix, std::string & suffix) throw();

  /**
     Finds 'item' and replaces it with 'target' within the string provided ('text').
     The result is returned.

     @param text Original string
     @param item Searched string
     @param target String which replaces the item
     @param all Boolean about replace all items or only the first found. True by default.

     @return Modified string
  */
  static std::string replace(const std::string & text, const char *item, const char *target, bool all = true) throw();

  /**
  * Coverts original string without quotation into quoted one: '\%s'
  */
  static std::string addQuotationMarks(const std::string & str) throw();
  static std::string addQuotationMarks(const char * str) throw();
  static std::string addQuotationMarks(const int & integer) throw();

  /**
  * Generates space-separated string lists based on integer elements
  * Also, another separator could be used.
  */
  static std::string vectorToStringRepresentation(const std::vector<int> & v, const char separator = ' ') throw();

  /**
  * Generates space-separated string lists based on string elements.
  * Also, another separator could be used.
  */
  static std::string vectorToStringRepresentation(const std::vector<std::string> & v, const char separator = ' ') throw();

  /**
     Returns socket notation 'Address:Port'
  */
  static std::string socketLiteralAsString(const std::string & address, int port) throw();

  /**
     Ascii string for buffer/size data block

     @param buffer Octet string buffer
     @param size Buffer size
     @param isFullyPrintable Returned by reference

     @return Ascii string representation, and dots for non-printable cheracters
  */
  static std::string asAsciiString(const char * buffer, int size, bool & isFullyPrintable) throw();

  /**
     Same as #asAsciiString but without interest about if is printable or not
  */
  static std::string asAsciiString(const char * buffer, int size) throw() {
    bool isFullyPrintable;
    return asAsciiString(buffer, size, isFullyPrintable);
  }

  /**
     Same as #asAsciiString providing anna::DataBlock
  */
  static std::string asAsciiString(const DataBlock & db, bool & isFullyPrintable) throw() {
    return asAsciiString(db.getData(), db.getSize(), isFullyPrintable);
  }

  /**
     Same as #asAsciiString providing DataBlock and without interest about if is printable or not
  */
  static std::string asAsciiString(const DataBlock & db) throw() {
    bool isFullyPrintable;
    return asAsciiString(db.getData(), db.getSize(), isFullyPrintable);
  }


  /**
   * IP Address enconding based on common database 'human-readable raw presentation':
   * <pre>
   *    Example for IPv4: 'AABBCCDD' will be DataBlock for '170.187.204.221'
   *    Example for IPv6: '20010DB885A3000000008A2E03707334' will be DataBlock for '2001:0db8:85a3:0000:0000:8a2e:0370:7334'
   *
   *    '000000000000000000000000AABBCCDD' will be encoded as 16-sized Datablock, not IPv4 (4 bytes). Is not recommended to
   *    put IPv4 on this way because of ambiguity regarding IPv4-compatible format. It is application responsability to trim
   *    leading zeros in order to use this method for IPv4 source.
   * </pre>
   *
   * @param rawPresentation Input IP address as raw presentation. Must be 8 or 32 sized for IPv4 and IPv6 respectively.
   *
   * @return Encoded DataBlock
   */
  static DataBlock rawIpPresentationAsRaw(const std::string & rawPresentation) throw(RuntimeException);


  /**
   * IP Address decoding from raw presentation:
   * <pre>
   *    Example for IPv4: 'AABBCCDD' will be '170.187.204.221'
   *    Example for IPv6: '20010DB885A3000000008A2E03707334' will be '2001:0db8:85a3:0000:0000:8a2e:0370:7334'
   *
   *    '000000000000000000000000AABBCCDD' will be internally encoded as 16-sized Datablock, not IPv4 (4 bytes).
   *    Is not recommended to put IPv4 on this way because of ambiguity regarding IPv4-compatible format. It is
   *    application responsability to trim leading zeros in order to use this method for IPv4 source.
   * </pre>
   *
   * @param rawPresentation Input IP address as raw presentation. Must be 8 or 32 sized for IPv4 and IPv6 respectively.
   * @param normalize Normalize returned address representation, 'false' by default (to avoid IPv4 to IPv6 conversion)
   *
   * @return Decoded IP address
   */
  static std::string rawIpPresentationToIpAsString(const std::string & rawPresentation, bool normalize = false) throw(RuntimeException) {
    return rawIpAsString(rawIpPresentationAsRaw(rawPresentation), normalize);
  }


  /**
   * IP Address decoding to 'human-readable raw presentation':
   * <pre>
   *    Example for IPv4: DataBlock for '170.187.204.221' will be 'AABBCCDD' (a pure IPv4 will never contain leading zeros outside of its scope (i.e., 24 zeros on a 32-character presentation)
   *    Example for IPv6: DataBlock for '2001:0db8:85a3:0000:0000:8a2e:0370:7334' will be '20010DB885A3000000008A2E03707334'
   *
   *    DataBlock for '::170.187.204.221' will be represented as IPv4 compatible: '000000000000000000000000AABBCCDD'
   * </pre>
   *
   * @param db Encoded DataBlock with 4 or 16 bytes to represent Ipv4 or Ipv6.
   *
   * @return Human-readable raw IP presentation
   */
  static std::string rawIpAsRawIpPresentation(const DataBlock & db) throw(RuntimeException);


  /**
   * Gets the host name (system name)
   *
   * @return Hostname
   */
  static std::string getHostname() throw();

  /**
   * Gets the domain name
   *
   * @return Domainname
   */
  static std::string getDomainname() throw();

  /**
   * Gets the FQDN (Fully Qualified Domain Name)
   *
   * @param hostname Specific provided hostname. Automatically solved if missing. Empty string implies exclusion from FQDN.
   * @param domainname Specific provided domainname. Automatically solved if missing. Empty string implies exclusion from FQDN.
   *
   * @return FQDN (<hostname>.<domainname>)
   */
  static std::string getFQDN(const char *hostname = NULL, const char  *domainname = NULL) throw();

  /**
   * Gets the IP based on hostname (#getHostname)
   *
   * @return Hostname-based IP
   */
  static std::string getHostnameIP() throw();



  //////////////////////////////////////////////////////////////////////////////////////////////////
  // IP Address resources //////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////////////////////////

  /**
  * IPv4 subtype (Estrict/Compatible)
  */
  struct IPv4Type {
    enum _v {
      Estrict = -1, // Initialized,
      Compatible,
      Mapped
    };
  };

  /**
  * IPv4 address family detection
  *
  * @param ip IP address
  * @param ipv4Type Check for IPv4-compatible (i.e. '::192.168.0.1'), IPv4-mapped (i.e. '2001:0db8:85a3:0000:0000:8a2e:192.168.0.1') or estrict IPv4 format.
  *
  * @return Boolean for IPv4 nature
  */
  static bool isIPv4(const std::string & ip, IPv4Type::_v ipv4Type = IPv4Type::Estrict) throw();

  /**
  * IPv6 address family detection
  *
  * @param ip IP address
  *
  * @return Boolean for IPv6 nature
  */
  static bool isIPv6(const std::string & ip) throw();

  /**
   * Convert an IPv4 address to IPv6. Also removes dots from IPv4-mapped format.
   *
   * @param ipv4 IP Address in dot notation (192.168.1.100)
   *
   * @return string IPv6 formatted address or launch exception if invalid input
   */
  static std::string IPv4To6(const std::string & ipv4) throw(RuntimeException);

  /**
   * Normalizes an IP address to long notation. Specially used for IPv6, but valid for IPv4 (via IPv4To6 conversion).
   *
   * Examples:
   *  ::1 ->                          0000:0000:0000:0000:0000:0000:0000:0001
   *  2001:db8:85a3::8a2e:370:7334 -> 2001:0db8:85a3:0000:0000:8a2e:0370:7334
   *
   * @param ip Input IP address
   *
   * @return Normalized IP address
   */
  static std::string normalizeIP(const std::string & ip) throw(RuntimeException);

  /**
   * Compare two IP addresses by mean normalization
   *
   * @param ip1 First IP address compared
   * @param ip2 Second IP address compared
   *
   * @return Boolean about IP's comparison
   */
  static bool sameIP(const std::string & ip1, const std::string & ip2) throw(RuntimeException);

  /**
   * Compare two IP addresses by mean internal comparison after ipv6 preffix restriction
   *
   * @param ipv6 IPv6 address matched
   * @param preffixedIpv6 Preffixed IPv6 address (<ipv6>/<preffix length>: only values from 0 (always match) to 128 (maximum restriction) are allowed).
   *
   * @return Boolean about subnet matching
   */
  static bool matchIPv6(const std::string & ipv6, const std::string & preffixedIpv6) throw(RuntimeException);

  /**
   * IP Address serialization
   *
   * @param ip Input IP address
   *
   * @return Encoded DataBlock
   */
  static DataBlock ipAsRaw(const std::string & ip) throw(RuntimeException);

  /**
   * IP Address decoding
   *
   * @param db Encoded DataBlock with 4 or 16 bytes to represent Ipv4 or Ipv6.
   * @param normalize Normalize returned address representation, 'false' by default (to avoid IPv4 to IPv6 conversion)
   *
   * @return Decoded IP address
   */
  static std::string rawIpAsString(const DataBlock & db, bool normalize = false) throw(RuntimeException) {
    return (rawIpAsString(db.getData(), db.getSize(), normalize));
  }

  /**
   * IP Address decoding
   *
   * @param buffer Encoded buffer with 4 or 16 bytes to represent Ipv4 or Ipv6.
   * @param bufferLength Encoded buffer length with 4 or 16 bytes to represent Ipv4 or Ipv6.
   * @param normalize Normalize returned address representation, 'false' by default (to avoid IPv4 to IPv6 conversion)
   *
   * @return Decoded IP address
   */
  static std::string rawIpAsString(const char *buffer, int bufferLength, bool normalize = false) throw(RuntimeException);

  /**
   * Abbreviates an IP address. Specially used for IPv6, but valid for IPv4.
   *
   * Examples:
   *  0000:0000:0000:0000:0000:0000:0000:0001 -> ::1
   *  2001:0db8:85a3:0000:0000:8a2e:0370:7334 -> 2001:db8:85a3::8a2e:370:7334
   *
   * @param ip Input IP address
   *
   * @return Abbreviated IP address
   */
  static std::string abbreviateIP(const std::string & ip) throw(RuntimeException) {
    return (rawIpAsString(ipAsRaw(ip)));
  }




  // socket literal description typedef, vectors and conversion tools

  /**
  * Extract ADDRESS (ip or hostname ro resolve) and PORT from socket literal description ('<ip|hostname>:<port>').
  *
  * @param literal Socket literal in format '<ip|hostname>:<port>'
  * @param address Address extracted by reference
  * @param port Port extracted by reference
  */
  static void getAddressAndPortFromSocketLiteral(const std::string &literal, std::string &address, int &port) throw();

  /**
  * Translate pipe-separated socket literal list into Address/Port vector.
  *
  * @param list Comma-separated Address/Port list. I.e.: '10.95.10.25:4000,10.95.10.25:4001', or 'fed1:4000,fed2:4001'
  * @return Address/Port socket items vector
  */
  static socket_v getSocketVectorFromString(const std::string & list) throw();

  /**
  * Translate Address/Port vector into comma-separated Address/Port list.
  *
  * @param socketVector Address/Port vector
  *
  * @return Comma-separated Address/Port list. I.e.: '10.95.10.25:4000,10.95.10.25:4001', or 'fed1:4000,fed2:4001'
  */
  static std::string socketVectorAsString(const socket_v & socketVector) throw();


  /**
    Endianess of the system

    @result Returns true when the system is little endian, false if big endian
  */
  static bool littleEndian() throw();

  /**
     Encodes an integer number with 32 bits over a buffer with at least 4 bytes of length.
     @param result Buffer where the number is encoded.
     @param n Number to encode.
     \return Buffer with the encoded number.
   */
  static const char* codeInteger(char* result, const int n) throw();

  /**
     Encodes an integer number with 16 bits over a buffer with at least 2 bytes of length.
     @param result Buffer where the number is encoded.
     @param n Number to encode.
     \return Buffer with the encoded number.
  */
  static const char* codeShort(char* result, const short int n) throw();

  /**
     Encodes an integer number with 64 bits over a buffer with at least 8 bytes of length.
     @param result Buffer where the number is encoded.
     @param n Number to encode.
     \return Buffer with the encoded number.
   */
  static const char* codeInteger64(char* result, const S64 n) throw();

  /**
     Encodes a floating number with 32 bits (according to the standard IEEE-754) over a buffer with at least 4 bytes of length.
     @param result Buffer where the number is encoded.
     @param n Number to encode.
     \return Buffer with the encoded number.
   */
  static const char* codeFloat(char* result, const float n) throw();

  /**
     Encodes a floating number with 64 bits (according to the standard IEEE-754) over a buffer with at least 8 bytes of length.
     @param result Buffer where the number is encoded.
     @param n Number to encode.
     \return Buffer with the encoded number.
   */
  static const char* codeDouble(char* result, const double n) throw();

  /**
     Decodes an 32 bits integer number contained in a 4-bytes buffer.
     @param data Buffer with the encoded number.
     @return Value for the number contained in the buffer.
  */
  static int decodeInteger(const char* data)  throw();

  /**
     Decodes an 16 bits integer number contained in a 2-bytes buffer.
     @param data Buffer with the encoded number.
     @return Value for the number contained in the buffer.
  */
  static short int decodeShort(const char* data)  throw();

  /**
     Decodes an 64 bits integer number contained in a 8-bytes buffer.
     @param data Buffer with the encoded number.
     @return Value for the number contained in the buffer.
  */
  static S64 decodeInteger64(const char* data)  throw();

  /**
     Decodes an 32 bits floating number (according to the standard IEEE-754) contained in a 4-bytes buffer.
     @param data Buffer with the encoded number.
     @return Value for the number contained in the buffer.
  */
  static float decodeFloat(const char* data)  throw();

  /**
     Decodes an 64 bits floating number (according to the standard IEEE-754) contained in a 8-bytes buffer.
     @param data Buffer with the encoded number.
     @return Value for the number contained in the buffer.
  */
  static double decodeDouble(const char* data)  throw();


  /**
  * Decodes an ISUP Number (called or calling party number).
  *
  * @param buffer Isup number content buffer.
  * @param length Isup number content length.
  * @param isupNumber Isup number decoded by reference.
  * @param calledOrCalling True for called party number, false for calling
  */
  static void decodeIsupNumber(const char *buffer, int length, isup_number_t & isupNumber, bool calledOrCalling) throw(RuntimeException);

  /**
  * Encodes an ISUP Number (called or calling party number).
  *
  * @param isupNumber Isup number.
  * @param calledOrCalling True for called party number, false for calling
  * @param buffer Isup number content encoded buffer.
  * @param length Isup number content encoded length.
  */
  static void codeIsupNumber(const isup_number_t & isupNumber, bool calledOrCalling, char * buffer, int & length) throw(RuntimeException);

  /**
  * Encodes an ISUP Number (called or calling party number).
  *
  * @param isupNumber Isup number.
  * @param calledOrCalling True for called party number, false for calling
  * @param target Isup number octet string.
  */
  static void codeIsupNumber(const isup_number_t & isupNumber, bool calledOrCalling, std::string & target) throw(RuntimeException);
};

}

#endif

