// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_http_internal_Token_hpp
#define anna_http_internal_Token_hpp

#include <string>

#include <anna/core/DataBlock.hpp>

namespace anna {

namespace http {

class Token : public DataBlock {
public:
  Token() : DataBlock(false) {;}

  const std::string& getStringValue() const throw();
  int getIntegerValue() const throw();
  bool contains(const char byte) const throw();

  void setValue(const char* content, const int size) throw() {
    setBuffer(content);
    setSize(size);
  }
  bool match(const char* str) const throw();
  int calculeOffset(const DataBlock& base) const throw(RuntimeException);

private:
  std::string a_aux;
};

}
}

#endif
