#!/bin/bash

quit() {
   echo
   echo $1
   echo
   exit
}

dependence () {
   FILE=$1
   BN_FILE=`basename $FILE`
   TMP_FILE=/var/tmp/.${BN_FILE}.tmp
   TMP2_FILE=/var/tmp/.${BN_FILE}.tmp2

   grep "<avprule id=" $FILE > $TMP_FILE
   > $TMP2_FILE

   while read -r line
   do
      AVP=$(echo $line | cut -d'"' -f2)
      if test "$AVP" != "AVP"
      then
         grep -l " name=\"$AVP\"" ${DN_DEPENDENCE}/avps_* >> $TMP2_FILE
      fi

   done < $TMP_FILE

   RESULT=`cat $TMP2_FILE | sort | uniq | grep -v "^${BN_FILE}$"`
   if test "$RESULT" != ""
   then
      for i in $RESULT
      do
         # To avoid infinite loop:
         processed=`echo $ACCUMULATED | grep -w $i`
         if test "$processed" = ""
         then
            ACCUMULATED="$ACCUMULATED $i"
            echo $i >> $RESULT_FILE
            dependence $i
         fi
      done
   fi
}



#############
# EJECUCION #
#############
[[ "$1" = "" ]] && quit "Use: $0 <dictionary>, i.e.: $0 commands_qosControl.xml, $0 avps_tme.xml, etc."
[[ ! -f "$1" ]] && quit "ERROR: file '$1' not found"
BN_FILE=`basename $1`
DN_DEPENDENCE=`dirname $0`
RESULT_FILE=/var/tmp/.${BN_FILE}.tmp3
> $RESULT_FILE
ACCUMULATED=

echo
echo "Finding dependences ..."
dependence $1

echo
echo "Generated '${1}.dep' with needed dictionaries:"
echo
cat $RESULT_FILE | sort | uniq > ${1}.dep
cat ${1}.dep
# Used for stackManagement: rm ${1}.dep
echo
HAVE_COMMANDS=`grep "<command name=" $1`
if test "$HAVE_COMMANDS" != ""
then
   echo "Your application must accumulate those resources to read '$1' and get it fully operative."
   echo "Note that probably you will need to add some more commands dictionary as 'Base Protocol' one (don't forget it)."
fi

cd /var/tmp
rm .*.tmp .*.tmp2 .*.tmp3
echo

